<?php
function is_gift_product_exist()
{
  global $woocommerce;
  $returnVal = '';
  $cart = $woocommerce->cart->get_cart();
  
  foreach ($cart as $key => $value){
    if( isset( $value['type'] ) && $value['type'] == 'gift_product'){
      $returnVal = 'added';
    }
  }
  return $returnVal;
}

function  get_gift_option()
{
  $result = get_option('_woo_gift_cat_name');
  return $result; 
}

function  get_gift_products_option()
{
  $result = get_option('_woo_gift_type_save');
  return $result; 
}

function get_gift_option_condition_values()
{
  $result = get_option('_woo_gift_condition_value');
  return $result; 
}

function get_existing_products_img($ids)
{
  $getImageSrc='';
  $get_thum_id=get_post_meta($ids,'_thumbnail_id');
  
  if(empty($get_thum_id))
  {
    $get_attached_images = (array) get_posts( array(
                                                    'post_type'   => 'attachment',
                                                    'post_parent' =>$ids
                                                   )
                                            );
    if (!empty($get_attached_images))
    {
      $img_src = $get_attached_images;
      $getImageSrc=$img_src[0]->guid;
    }
  }
  else
  {
    $get_single_post=get_post($get_thum_id[0]);
    $getImageSrc=$get_single_post->guid;
  }
  return $getImageSrc;
}

function get_new_gift_products($ids)
{
  $getImageSrc='';
  
  $get_attached_images = (array) get_posts( array(
                                                  'post_type'   => 'attachment',
                                                  'post_parent' =>$ids,
                                                 )
                                          );
  if (!empty($get_attached_images))
  {
    $img_src = $get_attached_images;
    $getImageSrc=$img_src[0]->guid;
  }
  return $getImageSrc;
}

function checkGiftCondition()
{
  if ( function_exists('woocommerce_gift_manager_install') && class_exists('Woocommerce') ) 
  {
    if( is_cart() )
    {
      global $woocommerce;
      $storeGiftId = '';
      $get_option_name = get_gift_option();

      $option_conditions_val = get_gift_option_condition_values();

      //condition for multiple subtotal
      if($get_option_name['giftCatName']=='multiple_subtotal')
      {
          $getRnageData = $option_conditions_val['subtotal_amount_range_multiple'];
          
          if( $getRnageData )
          {
            $parseRangeData = explode('##', $getRnageData);
            foreach ($parseRangeData as $data)
            {
                $parse2 = explode('#', $data);
                $parse3 = explode(',', $parse2[1]);

                if(!empty($parse3[0]) && !empty($parse3[1]))
                {
                  if($woocommerce->cart->subtotal >= $parse3[0] && $woocommerce->cart->subtotal <= $parse3[1 ])
                  {
                    $storeGiftId .=$parse2[0].',';
                  }
                }
                else if(!empty($parse3[0]) && empty($parse3[1]))
                {
                  if($woocommerce->cart->subtotal >=$parse3[0])
                  {
                    $storeGiftId .=$parse2[0].',';
                  }
                }
                else if(empty($parse3[0]) && !empty($parse3[1]))
                {
                  if($woocommerce->cart->subtotal <=$parse3[1])
                  {
                    $storeGiftId .=$parse2[0].',';
                  }
                }
            }

            if( trim($storeGiftId,',') )
            {
              $storeGiftId = trim($storeGiftId,',');
            }
          }
      }

      //condition for category
      else if($get_option_name['giftCatName']=='category')
      { 
        if(!empty($option_conditions_val['cat_products_ids']))
        {
           $store_data='';
           $checkStr='';
           $products=$option_conditions_val['cat_products_ids'];

           if($products)
           {
             $selected_ids_array=explode(',',trim($products,','));
           }
           $cart_products_ids= $woocommerce->cart->get_cart( );

           if($cart_products_ids)
           {
            foreach($cart_products_ids as $cart_item_key => $rows)
            {
              if( !isset( $rows['type'] ) )
              {
                $ids=$rows['product_id'];
                $terms = get_the_terms( $ids, 'product_cat' );
                if($terms)
                {
                  foreach($terms as $rows)
                  {
                    $store_data.=$rows->term_id.'#'.$ids.',';
                  }
                }
              }
            }
           }
           
           if(trim($store_data,','))
           {
             $check_array=explode(',',trim($store_data,','));
           }

           if( isset($selected_ids_array) && isset($check_array))
           {
             $commonVal = array_intersect($selected_ids_array, $check_array);
           }

           if( isset($commonVal) && count($commonVal)>0)
           {
             $storeGiftId = 'condition_true';
           }
        }
      }

      //condition for number of cat products
      else if($get_option_name['giftCatName']=='numberof_category_products')
      {
        $sumArray = array();
        $adminCatId = array();
        $adminId = array();
        $finalArray = array();

        $products=$option_conditions_val['numberOfCatProducts'];
        $cart_products_ids= $woocommerce->cart->get_cart();

        if($cart_products_ids)
        {
          foreach($cart_products_ids as $rows)
          {
            if( !isset( $rows['type'] ) )
            {
              $qty = $rows['quantity']; 
              $ids = $rows['product_id'];
              $terms = get_the_terms( $ids, 'product_cat');

              if($terms)
              {
                foreach($terms as $rowsCat)
                {
                  if( !isset($sumArray[$rowsCat->term_id]) )
                  {
                    $sumArray[$rowsCat->term_id] = $qty;
                  }
                  elseif (isset($sumArray[$rowsCat->term_id])) 
                  {
                    $sumArray[$rowsCat->term_id] += $qty;
                  }
                }
              }
            }
          }
        }
        if($products)
        {
          $adminId = explode('#', $products);
          if( $adminId )
          {
            foreach ($adminId as $value)
            {
              $parseAdmin = explode(',', $value);
              $adminCatId[$parseAdmin[0]] = $parseAdmin[1];
            }
          }
        }

        if(isset($adminCatId) && isset($sumArray))
        {
          foreach ($sumArray as $key => $value)
          {
            if(array_key_exists($key, $adminCatId))
            {
              if( $value >= $adminCatId[$key] )
              {
                $finalArray [$key] = $value;
              }
            }
          }
        }

        if( isset($finalArray) && count($finalArray)>0)
        {
          $storeGiftId = 'condition_true';
        }
      }

      //check condition for item
      else if($get_option_name['giftCatName']=='item')
      {
        $isGift = '';
        if(!empty($option_conditions_val['total_items']))
        {
          foreach ( $woocommerce->cart->get_cart() as $cart_item_key => $cart_item ) 
          {
            if( isset( $cart_item['type'] )  && $cart_item['gift_product'])
            {
              $isGift = 'yes';
            }
          }
          if( $isGift && $isGift == 'yes' )
          {
            $cart_item_count=$woocommerce->cart->cart_contents_count - 1;
          }
          else
          {
            $cart_item_count=$woocommerce->cart->cart_contents_count;
          }
          
          if($cart_item_count >= $option_conditions_val['total_items'])
          {
            $storeGiftId = 'condition_true';
          }
        }
      }

      //check condition for any products
      else if($get_option_name['giftCatName']=='any_products')
      {
        $cart_items =  $woocommerce->cart->get_cart();
        $cart_item_count=$woocommerce->cart->cart_contents_count;
        if($cart_item_count >=1)
        {
          $storeGiftId = 'condition_true';
        }
      }
      return $storeGiftId;
    }  
  }  
}

function display_gift_popup_in_frontend()
{
  if (function_exists('woocommerce_gift_manager_install') && class_exists('Woocommerce')) 
  {
    $get_option_name = get_gift_option();
    
    if( is_shop() && $get_option_name['giftCatName'] !=='disable' || is_product() && $get_option_name['giftCatName'] !=='disable' )
    {
      $megs = woo_gift_manager_get_gift_message();
      if( $megs )
      {
        echo '<div class="gift_msg_container"><div class="gift_msg_text">'. $megs .'</div></div>';
      }  
    }
    
    if( is_cart())
    {
      $get_options = woo_gift_manager_get_gift_popup_title();
       
      $conditionStatus = checkGiftCondition();
      
      if( ($conditionStatus && $conditionStatus !== 'condition_true' || $conditionStatus && $conditionStatus === 'condition_true') && $get_options['added_options'] === 'from_slider' )
      {
        gift_popup_content( $conditionStatus );
      }
    }
  }
}

function gift_popup_content($giftByProductId)
{
  global $woocommerce;
  $cart_url = $woocommerce->cart->get_cart_url();
  
  $products_list=array();
  $get_products=get_gift_products_option();
  $get_popup_title_style=woo_gift_manager_get_gift_popup_title();
  $isGiftExist = is_gift_product_exist();
  
  if(!empty($get_products['existing_products']) && $get_products['gift_type_name']=='products')
  {
    $get_products_ids = $get_products['existing_products'];
    
    $products_ids_array=explode(',',  trim($get_products_ids,','));
    foreach($products_ids_array as $ids){
      $data = new stdClass();
      $data->id =$ids;
      $data->img_url =get_existing_products_img($ids);
      $data->type ='existing';
      $products_list[] = $data;
    }
  }
  else if(!empty($get_products['new_products']) && $get_products['gift_type_name']=='new_products') 
  {
    $get_products_ids=$get_products['new_products'];
    $products_ids_array=explode(',',  trim($get_products_ids,','));
    foreach($products_ids_array as $ids){
      $data = new stdClass();
			$data->id =$ids;
			$data->img_url =get_new_gift_products($ids);
      $data->type ='new';
      $products_list[] = $data;
    }
  }
  else if($get_products['gift_type_name']=='products' && !empty($giftByProductId)) 
  {
    if(!empty($giftByProductId))
    {
      $checkComma= strpos($giftByProductId,',');
      if(!empty($checkComma))
      {
        $parseId=  explode(',', $giftByProductId);
        $uArray=  array_unique($parseId);
        foreach ($uArray as $id)
        {
          $data = new stdClass();
          $data->id =$id;
          $data->img_url =get_existing_products_img($id);
          $data->type ='existing';
          $products_list[] = $data; 
        }
      }
      else
      {
        $data = new stdClass();
        $data->id =$giftByProductId;
        $data->img_url =get_existing_products_img($giftByProductId);
        $data->type ='existing';
        $products_list[] = $data;
      }
    }
  }
  else if($get_products['gift_type_name']=='new_products' && !empty($giftByProductId)) 
  {
    if(!empty($giftByProductId))
    {
      $checkComma= strpos($giftByProductId,',');
      if(!empty($checkComma))
      {
        $parseId=  explode(',', $giftByProductId);
        $uArray=  array_unique($parseId);
        foreach ($uArray as $id)
        {
          $data = new stdClass();
          $data->id =$id;
          $data->img_url =get_existing_products_img($id);
          $data->type ='existing';
          $products_list[] = $data; 
        }
      }
      else
      {
        $data = new stdClass();
        $data->id =$giftByProductId;
        $data->img_url =get_existing_products_img($giftByProductId);
        $data->type ='existing';
        $products_list[] = $data;
      }
    }
  }
?>

<script src="http://code.jquery.com/ui/1.10.4/jquery-ui.js"></script>
<link href="<?php echo plugins_url('',__FILE__)?>/resource/css/gift_system.css" type="text/css" rel="stylesheet"  />
	
<script type="text/javascript">
  
  function closepopup()
  {
    jQuery('.popupdiv').hide('slide', { direction: 'right' }, 700);
  }

  jQuery(document).ready(function()
  {
    
//    if(jQuery('table.shop_table').length>0)
//    {
//      jQuery('table.shop_table .cart_item dd').each(function() 
//      {
//        var design_type = jQuery(this).find('p').html();
//        
//        if( design_type === 'Gift Product' )
//        {
//          jQuery(this).parents('tr').find('.quantity').html('');
//          jQuery(this).parents('tr').find('.quantity').html('<div style="color:#000000;font-weight:bold;border:2px solid #EBE8EB;padding-left: 15px;">1</div>');
//        }
//      });   
//    }  
    
    <?php if(!$isGiftExist){?>
    jQuery('.popupdiv').show('slide', { direction: 'right' }, 1800);
    <?php }?>
      
    jQuery(".slide img:eq(0)").addClass('active');
    var imagewidth = jQuery('.slide').outerWidth();
    var totalimages = jQuery('.slide img').size();
    //var getLeftValue= 	jQuery("div.slide").css("margin-left");
    
    //var leftValue= parseInt(getLeftValue) * parseInt(totalimages);
    
    //var sliderwidth = (parseInt(imagewidth) * parseInt(totalimages)) + parseInt(leftValue);
    var sliderwidth = (parseInt(imagewidth) * parseInt(totalimages));
    jQuery('#slider-wrapper').css({'width': sliderwidth});

    if(totalimages>1){
      jQuery('#NextButton').show();
    }
    else{
      jQuery('#NextButton').hide();
    }

    jQuery('#NextButton').click(function(){
      var active_alt = jQuery('.slide img.active').attr('alt');
      jQuery('.slide img').removeClass('active');
      var active = jQuery(".slide img:eq("+  parseInt(active_alt) + ")").addClass('active');
      var count = active.attr('alt') - 1;
      //var sliderposition = (parseInt(count) * parseInt(imagewidth)) + (parseInt(count) * parseInt(getLeftValue));
      var sliderposition = (parseInt(count) * parseInt(imagewidth));

      jQuery('#slider-wrapper').animate({'margin-left': - sliderposition}, 500);

      var active_alt = jQuery('.slide img.active').attr('alt');
      active = jQuery(".slide img:eq("+ parseInt(active_alt) +")");
      
      if (active.length == 0){                                 
            jQuery('#NextButton').hide();
        }
      if(active_alt>1){
        jQuery('#PreviousButton').show();
      }
    });

    jQuery('#PreviousButton').click(function(){
      var active_alt = jQuery('.slide img.active').attr('alt');
      jQuery('.slide img').removeClass('active');
      var preImg = active_alt - 2;
      
      var active = jQuery(".slide img:eq("+ parseInt( preImg ) +")").addClass('active');
      var count = active.attr('alt') - 1;
      //var sliderposition = (parseInt(count) * parseInt(imagewidth)) + (parseInt(count) * parseInt(getLeftValue));
      var sliderposition = (parseInt(count) * parseInt(imagewidth));
      jQuery('#slider-wrapper').animate({'margin-left': -sliderposition}, 500);

      var active_alt = jQuery('.slide img.active').attr('alt');
      
      if (active_alt == 1)
      {                                  
        jQuery('#PreviousButton').hide();
      }
      var active_alt = jQuery('.slide img.active').attr('alt');
      active=jQuery(".slide img:eq("+ parseInt(active_alt) +")");

      if(active.length>0)
      {
        jQuery('#NextButton').show();
      }   
    });
//      jQuery('.sliderGiftProducts').bxSlider({
//        slideWidth:120,
//        minSlides: 1,
//        maxSlides: 5,
//        slideMargin:5
//      });
  });

  function get_checkbox_value(obj)
  {
    jQuery("#hfSelected_value").val(jQuery("#" + obj.id).val());
  }
  function save_product()
  {
    if(jQuery("#hfSelected_value").val()!='')
    {
      var ajax_url = '<?php echo admin_url( 'admin-ajax.php' ); ?>';
      jQuery.ajax({
        type: "POST",
        url:ajax_url,
        data : {
                'action':   'save_gift_id_by_order',
                'gift_id':  jQuery("#hfSelected_value").val().split(',')[0]
        },
        success: function(response){
          if(response == 'cart_updated' || response ){
            window.location.href = '<?php echo $cart_url;?>';
            //jQuery('.popupdiv').hide('slide', { direction: 'right' }, 700);
          }
        }
      });
    }
    else
    {
      alert("Please select any gift product");
    }
  }    
</script>
<style type="text/css">
  .btn_control a
  {
    text-decoration: none !important;
  }

  .title_style{
    width: 100%;
    text-align: center;
    font-size: <?php echo $get_popup_title_style['title_text_font_size'];?>px !important;
    font-weight: bold;
    color: <?php echo '#'.$get_popup_title_style['title_text_font_color'];?> !important;
    height:24px;
    margin-top:7px;
  }

  #scgm_container
  {
    width:100%;
    height:150px;
    overflow: hidden;
    position:relative;
    padding-top:5px;
    /*margin:30px;*/
  }
  .slide
  {
    float:left;
    /*margin-left:18px;*/
    text-align:center;
    width:362px;
  }
  .slide img
  {
    height:80px;
    display:block;
    margin:0px auto;
  }

  #scgm_container div.control_button
  {
    position:absolute;
    top:45%;
    left:2%;
    height:20px;
    width:96%;
  }
  #scgm_container div.control_button a#NextButton
  {
    float:right;	
  }
  .slider-product-price
  {
    text-decoration: line-through;
  }
  .slider-products-name,.slider-product-price,.slider-product-select
  {
    color:#444444;
    font-size:12px;
    padding-bottom:2px;
  }
</style>
  <?php if(count($products_list)>0){?>
	<div class="popupdiv" style="display:none;">
    <div class="title_style"><?php echo $get_popup_title_style['title_text'];?></div>
    <input type="hidden" name="hfSelected_value" id="hfSelected_value"/>
    <div id="scgm_container">
      <div class="control_button">
        <a style="display:none;" href="javascript:void(0)" id="PreviousButton"><img src="<?php echo plugins_url('',__FILE__);?>/resource/img/prev.png" /></a>
        <a href="javascript:void(0)" id="NextButton"><img src="<?php echo plugins_url('',__FILE__);?>/resource/img/next.png" /></a>
      </div>
      <div id="slider-wrapper">
        <?php
        $i=1;
        foreach($products_list as $img){
        ?>
        <div class="slide">
          <div><img src="<?php echo $img->img_url;?>" alt="<?php echo $i;?>" /></div>
          <div class="slider-products-name"><?php echo get_the_title( $img->id ); ?></div>
          <div class="slider-product-price"><?php echo _e('Price', 'wgmp');?>:&nbsp;<?php echo get_woocommerce_currency_symbol().get_post_meta($img->id, '_price', TRUE); ?></div>
          <div class="slider-product-select"><input type="radio" id="Selectproducts_<?php echo $img->id;?>" name="radio_gift_products" value="<?php echo $img->id .','.$img->type;?>" onclick="get_checkbox_value(this);"/><?php echo _e('Choose', 'wgmp');?></div>
        </div>
        <?php $i++;}?>
      </div>
    </div>
    <div style="float: right;" class="btn_control">
      <div style="float: left;width:30px;"><a title="ok" class="button_style" href="javascript:void(0)" onclick="save_product();"><?php echo _e('OK', 'wgmp');?></a></div>
      <div style="float: left;margin-right: 20px;"><a title="Close"  class="button_style" href="javascript:void(0)" onclick="closepopup();"><?php echo _e('CLOSE', 'wgmp');?></a></div>
      <div style="clear: both;"></div>
    </div>
	</div>
<?php
  }
}

function gift_added_automatically_content()
{
  ob_start();
  
  global $wpdb,$woocommerce;
  $conditionStatus = checkGiftCondition();
  $get_options     = woo_gift_manager_get_gift_popup_title();
  $get_products    = get_gift_products_option();
  
  if( ($conditionStatus && $conditionStatus !== 'condition_true' || $conditionStatus && $conditionStatus === 'condition_true') && $get_options['added_options'] === 'automatically' )
  {
    $gift_item = '';
    if($conditionStatus === 'condition_true')
    {
      $gift_item = $get_products['existing_products'];
    }
    else
    {
      $gift_item = $conditionStatus;
    }
    
    foreach ( $woocommerce->cart->get_cart() as $cart_item_key => $cart_item ) 
    {
      if( isset( $cart_item['type'] ) && $cart_item['type'] == 'gift_product')
      {
        $cart = $woocommerce->cart;
        $cart_item_id = $cart->find_product_in_cart( $cart_item_key );
        if( $cart_item_id )
        {
          $cart->set_quantity($cart_item_id, 0);
        }
      }
    }
    
    $product_id =  explode(',', trim($gift_item, ','));
    
   
    foreach ($product_id as $id)
    {
      $woocommerce->cart->add_to_cart( $id, 1, null, null, array('type' => 'gift_product') );
    }
  }
  
  return ob_get_clean();
}

function save_gift_id_by_order()
{
		global $woocommerce;
  if($woocommerce->cart->add_to_cart( $_REQUEST['gift_id'], 1, null, null, array('type' => 'gift_product') ) ){
    echo 'cart_updated';
  }
  exit;
}

function save_gift_by_order()
{
  global $woocommerce;
		$final_product_id = $_REQUEST['gift_id'];
  
  if($woocommerce->cart->add_to_cart( $final_product_id, 1, null, null, array('type' => 'gift_product') ) ){
    echo 'cart_updated';
  }
  exit;
}
add_action( 'wp_ajax_nopriv_save_gift_id_by_order','save_gift_id_by_order' );
add_action( 'wp_ajax_save_gift_id_by_order', 'save_gift_id_by_order' );
?>