<?php 
/*
Plugin Name:  Woocommerce Gift Manager
Plugin URI:   http://www.solvercircle.com
Description:  "WooCommerce Gift Manager" plugin allow you to manage or create free gift products/items with custom settings from admin.
Version:      2.4
Author:       20script
Author URI:   http://www.20script.ir
*/

if(!defined('ABSPATH')) exit;
  
define('WOO_GIFT_MANAGER_URL', plugins_url('',__FILE__));
include ('includes/woocommerce-gift-system-init.php');
include ('includes/woocommerce-gift-system-admin-page.php');
include ('includes/templates/gift-template-a/gift-system-template.php');
include ('includes/woocommerce-subtotal-range.php');
  
function woo_gm_load()
{
  wp_enqueue_script( 'jquery' );
  wp_enqueue_script( 'jquery-ui-core' );
  wp_enqueue_script( 'jquery-ui-dialog' );
  wp_enqueue_script( 'ajaxUpload',WOO_GIFT_MANAGER_URL.'/js/ajaxupload.3.5.js');
  wp_enqueue_script( 'colorJS',WOO_GIFT_MANAGER_URL.'/js/colorpicker/jscolor.js');
  wp_enqueue_style(  'gift-css',WOO_GIFT_MANAGER_URL.'/css/woocommerce-gift-system.css');
  wp_enqueue_script( 'custom-common', WOO_GIFT_MANAGER_URL.'/js/common.js');
  
  load_plugin_textdomain_urls();
}
  
function woo_gm_templates_dir() 
{
  $possible_directories = path_join(dirname(__FILE__), 'includes/templates');
  $dirarr=array();
  if ($handle = opendir($possible_directories)) 
  {
    while (false !== ($entry = readdir($handle))) 
    {
      if($entry != "." && $entry != "..") 
      {
        $dirarr[]=array('name'=>$entry,
                        'directory'=>path_join(dirname(__FILE__), 'includes/templates/'.$entry),
                        'screenshot'=>plugins_url('/includes/templates/'.$entry.'/screenshot.png',__FILE__));
      }
    }			
    closedir($handle);
  }
  $dirarr = woo_gm_sort_template_name($dirarr,'name');
  return $dirarr;
}
	
function woo_gm_sort_template_name(&$array, $key) 
{
  $sorter=array();
  $ret=array();
  reset($array);
  foreach ($array as $ii => $va) 
  {
    $sorter[$ii]=$va[$key];
  }
  asort($sorter);
  foreach ($sorter as $ii => $va) 
  {
    $ret[$ii]=$array[$ii];
  }
  $array=$ret;
  return $array;
}
 
function add_custom_price( $cart_object ) 
{
  global $woocommerce;
  
  foreach ( $cart_object->cart_contents as $key => $value ){
    if( isset( $value['type'] ) && $value['type'] == 'gift_product' && count($cart_object->cart_contents) == 1 ){
      $woocommerce->cart->empty_cart();
    }
				
    if ( isset( $value['type'] ) && $value['type'] == 'gift_product' && count($cart_object->cart_contents)>1 ){
						$value['data']->set_price( 0 );
    }
  }  
}

function custom_woocommerce_update_cart_action()
{
  if (class_exists('Woocommerce')) {
    global $woocommerce;
    
    if( is_cart() ){
      $conditionStatus = checkGiftCondition();
						
      foreach ( $woocommerce->cart->get_cart() as $cart_item_key => $cart_item ) {
        if( isset( $cart_item['type'] ) && $cart_item['type'] =='gift_product' && !$conditionStatus ){
          $cart = $woocommerce->cart;
          $cart_item_id = $cart->find_product_in_cart( $cart_item_key );
										
          if( $cart_item_id ){
            $cart->set_quantity($cart_item_id, 0);
          }
        }
      }
    }
  }
}

function automatically_content()
{    
  gift_added_automatically_content();
}

function load_plugin_textdomain_urls() {
		load_plugin_textdomain( 'wgmp', false, 'woocommerce-gift-manager/languages');
}

add_filter( 'woocommerce_cart_item_name', 'gm_filter_woocommerce_cart_item_name', 10, 3 );
function gm_filter_woocommerce_cart_item_name($name, $cart_item, $cart_item_key){
		$name_content = '';
			
		if(count($cart_item) > 0){
				if(isset($cart_item['type']) && $cart_item['type'] == 'gift_product'){
						$name_content .= '<div class="product-name">'. $name .'</div>';
						$name_content .= '<div class="custom-design-text">Type: Gift Product</div>';
				}
				else{
						$name_content = $name;
				}
		}
		
		return $name_content;
}

add_action('woocommerce_add_order_item_meta', 'gm_add_order_item_meta', 10, 2);
function gm_add_order_item_meta($item_id, $values) {
		
		if(isset($values['type']) && $values['type'] == 'gift_product'){
				woocommerce_add_order_item_meta($item_id, 'Type', 'Gift Product');
		}
}


add_action('woocommerce_before_cart_contents', 'automatically_content');
add_action( 'woocommerce_before_calculate_totals', 'add_custom_price' );
add_action( 'init','woo_gm_load');
add_action( 'wp_head','custom_woocommerce_update_cart_action');
add_action( 'wp_footer', 'display_gift_popup_in_frontend');
register_activation_hook(__FILE__, 'woocommerce_gift_manager_install');
register_deactivation_hook(__FILE__, 'woocommerce_gift_manager_uninstall');
?>